﻿Imports System.IO
Imports System.Text

Public Class Form1

    Private Structure Operator_Struct

        Dim AR As Integer
        Dim D1R As Integer
        Dim D2R As Integer
        Dim RR As Integer
        Dim D1L As Integer
        Dim TL As Integer
        Dim KS As Integer
        Dim MUL As Integer
        Dim DT1 As Integer
        Dim DT2 As Integer
        Dim AME As Integer

    End Structure

    Private Structure Voice_Struct

        Dim Name As String

        Dim LFRQ As Integer
        Dim AMD As Integer
        Dim PMD As Integer
        Dim WF As Integer
        Dim NFRQ As Integer

        Dim PAN As Integer
        Dim FL As Integer
        Dim CON As Integer
        Dim AMS As Integer
        Dim PMS As Integer
        Dim SLOT As Integer
        Dim NE As Integer

        Dim Op() As Operator_Struct

    End Structure

    Private Structure CurrVoice_Struct
        Dim VolumeChangeAmount As Integer
        Dim Voice As Voice_Struct
    End Structure

    Dim utf8WithoutBom As New System.Text.UTF8Encoding(False)
    Dim in_file As FileStream
    Dim filepos As Integer
    Dim filelength As Integer
    Dim d(3) As Byte
    Dim temp As Integer
    Dim delay As Integer = 0
    Dim ym_reg As Integer
    Dim ym_val As Integer

    Dim Note(7) As Integer
    Dim Note_Old(7) As Integer
    Dim NoteOn(7) As Boolean
    Dim NoteOn_Old(7) As Boolean
    Dim Slot(7) As Integer
    Dim KF(7) As Integer
    Dim KF_old(7) As Integer

    Dim MIDIByteCount As Integer
    Dim out_file_midi As FileStream
    Dim out_file_syx As FileStream
    Dim out_file_opm As StreamWriter

    Dim Registers(255) As Byte
    Dim AMD As Byte
    Dim PMD As Byte
    Dim RegisterChanged As Boolean

    Dim CurrentVoice(7) As CurrVoice_Struct
    Dim Voices() As Voice_Struct
    Dim VoicesCount As Integer
    Dim VoiceID(7) As Integer
    Dim VoiceID_old(7) As Integer
    Dim VolumeChangeAmount_old(7) As Integer
    Dim TL_Tol As Integer
    Dim MaxVol As Double
    Dim Gain As Double
    Dim BPM As Double
    Dim TQN As Integer

    Private Sub Send_Midi(Command As Integer, Param1 As Integer, Param2 As Integer)

        Dim t(3) As Byte
        Dim delay2 As Integer
        Dim delay3 As Double

        delay3 = 44100 / TQN
        delay3 = delay3 * 60 / BPM
        delay3 = delay / delay3

        delay2 = delay3

        t(0) = (delay2 >> 21) And 127
        t(1) = (delay2 >> 14) And 127
        t(2) = (delay2 >> 7) And 127
        t(3) = delay2 And 127

        If t(0) <> 0 Then out_file_midi.WriteByte(t(0) Or 128) : MIDIByteCount = MIDIByteCount + 1
        If t(1) <> 0 Then out_file_midi.WriteByte(t(1) Or 128) : MIDIByteCount = MIDIByteCount + 1
        If t(2) <> 0 Then out_file_midi.WriteByte(t(2) Or 128) : MIDIByteCount = MIDIByteCount + 1
        out_file_midi.WriteByte(t(3)) : MIDIByteCount = MIDIByteCount + 1

        delay = 0

        If (Command <> -1) Then out_file_midi.WriteByte(Command) : MIDIByteCount = MIDIByteCount + 1
        If (Param1 <> -1) Then out_file_midi.WriteByte(Param1) : MIDIByteCount = MIDIByteCount + 1
        If (Param2 <> -1) Then out_file_midi.WriteByte(Param2) : MIDIByteCount = MIDIByteCount + 1

    End Sub

    Private Function CompareVoice(v1 As Voice_Struct, v2 As Voice_Struct) As Boolean

        Dim op As Integer

        If (v1.LFRQ <> v2.LFRQ) Then Return (False)
        If (v1.AMD <> v2.AMD) Then Return (False)
        If (v1.PMD <> v2.PMD) Then Return (False)
        If (v1.WF <> v2.WF) Then Return (False)
        If (v1.NFRQ <> v2.NFRQ) Then Return (False)

        If (v1.PAN <> v2.PAN) Then Return (False)
        If (v1.FL <> v2.FL) Then Return (False)
        If (v1.CON <> v2.CON) Then Return (False)
        If (v1.AMS <> v2.AMS) Then Return (False)
        If (v1.PMS <> v2.PMS) Then Return (False)
        If (v1.SLOT <> v2.SLOT) Then Return (False)
        If (v1.NE <> v2.NE) Then Return (False)

        For op = 0 To 3

            If (v1.Op(op).AR <> v2.Op(op).AR) Then Return (False)
            If (v1.Op(op).D1R <> v2.Op(op).D1R) Then Return (False)
            If (v1.Op(op).D2R <> v2.Op(op).D2R) Then Return (False)
            If (v1.Op(op).RR <> v2.Op(op).RR) Then Return (False)
            If (v1.Op(op).D1L <> v2.Op(op).D1L) Then Return (False)
            If (Math.Abs(v1.Op(op).TL - v2.Op(op).TL) > TL_Tol) Then Return (False)
            If (v1.Op(op).KS <> v2.Op(op).KS) Then Return (False)
            If (v1.Op(op).MUL <> v2.Op(op).MUL) Then Return (False)
            If (v1.Op(op).DT1 <> v2.Op(op).DT1) Then Return (False)
            If (v1.Op(op).DT2 <> v2.Op(op).DT2) Then Return (False)
            If (v1.Op(op).AME <> v2.Op(op).AME) Then Return (False)

        Next

        Return (True)

    End Function

    Private Function FindVoice(v As Voice_Struct) As Integer

        Dim i As Integer
        Dim found As Integer

        found = -1
        If (VoicesCount > 0) Then
            i = 0
            Do
                If (CompareVoice(v, Voices(i))) Then found = i
                i = i + 1
            Loop Until ((found <> -1) Or (i >= VoicesCount))
        End If

        If (found = -1) Then
            AddVoice(v)
            found = VoicesCount - 1
        End If

        Return (found)

    End Function

    Private Sub AddVoice(v As Voice_Struct)

        VoicesCount = VoicesCount + 1

        ReDim Preserve Voices(VoicesCount - 1)

        Voices(VoicesCount - 1) = v

    End Sub

    Private Function GetCurrentVoice(chan As Integer) As CurrVoice_Struct

        Dim curr_voice As CurrVoice_Struct
        Dim op As Integer
        Dim TL_Min As Integer
        'Dim TL_Change_Count As Integer

        ReDim curr_voice.Voice.Op(3)

        curr_voice.Voice.Name = ""

        curr_voice.Voice.AMS = Registers(&H38 + chan) And 3
        curr_voice.Voice.PMS = (Registers(&H38 + chan) >> 4) And 7

        If ((curr_voice.Voice.AMS <> 0) Or (curr_voice.Voice.PMS <> 0)) Then
            curr_voice.Voice.LFRQ = Registers(&H18)
            curr_voice.Voice.AMD = AMD
            curr_voice.Voice.PMD = PMD
        Else
            curr_voice.Voice.LFRQ = 0
            curr_voice.Voice.AMD = 0
            curr_voice.Voice.PMD = 0
        End If

        curr_voice.Voice.WF = Registers(&H1B) And 3
        curr_voice.Voice.NFRQ = Registers(&HF) And 127
        curr_voice.Voice.PAN = Registers(&H20 + chan) And 192
        curr_voice.Voice.FL = (Registers(&H20 + chan) >> 3) And 7
        curr_voice.Voice.CON = Registers(&H20 + chan) And 7
        curr_voice.Voice.SLOT = Registers(&H8) And 120
        curr_voice.Voice.NE = Registers(&HF) And 128

        For op = 0 To 3

            curr_voice.Voice.Op(op).AR = Registers(&H80 + chan + (op * 8)) And 31
            curr_voice.Voice.Op(op).D1R = Registers(&HA0 + chan + (op * 8)) And 31
            curr_voice.Voice.Op(op).D2R = Registers(&HC0 + chan + (op * 8)) And 31
            curr_voice.Voice.Op(op).RR = Registers(&HE0 + chan + (op * 8)) And 15
            curr_voice.Voice.Op(op).D1L = (Registers(&HE0 + chan + (op * 8)) >> 4) And 15
            curr_voice.Voice.Op(op).TL = Registers(&H60 + chan + (op * 8)) And 127
            curr_voice.Voice.Op(op).KS = (Registers(&H80 + chan + (op * 8)) >> 6) And 3
            curr_voice.Voice.Op(op).MUL = Registers(&H40 + chan + (op * 8)) And 15
            curr_voice.Voice.Op(op).DT1 = (Registers(&H40 + chan + (op * 8)) >> 4) And 7
            curr_voice.Voice.Op(op).DT2 = (Registers(&HC0 + chan + (op * 8)) >> 6) And 3
            curr_voice.Voice.Op(op).AME = Registers(&HA0 + chan + (op * 8)) And 128

        Next

        'maximise volume
        TL_Min = 255
        'TL_Change_Count = 0
        For op = 0 To 3
            If (Carrier(curr_voice.Voice.CON, op)) Then
                If (TL_Min > curr_voice.Voice.Op(op).TL) Then TL_Min = curr_voice.Voice.Op(op).TL
            End If
        Next

        If (TL_Min <= 127) Then

            For op = 0 To 3
                If (Carrier(curr_voice.Voice.CON, op)) Then
                    curr_voice.Voice.Op(op).TL = curr_voice.Voice.Op(op).TL - TL_Min
                    'TL_Change_Count = TL_Change_Count + 1
                End If
            Next

            curr_voice.VolumeChangeAmount = TL_Min
            'ListBox2.Items.Add("VolumeChangeAmount= " + TL_Min.ToString)

        Else
            curr_voice.VolumeChangeAmount = 0
            ListBox2.Items.Add("Did not find minimum TL")
        End If

        Return (curr_voice)

    End Function

    Private Sub SendYM()

        Dim KF_PB As Integer
        Dim Chan As Integer
        Dim Vol As Double

        Registers(ym_reg) = ym_val

        Select Case (ym_reg)

            Case &H8
                'Key on
                Chan = ym_val And &H7

                Slot(Chan) = (ym_val And &H78) >> 3
                NoteOn_Old(Chan) = NoteOn(Chan)

                If (Slot(Chan) <> 0) Then
                    'If (RegisterChanged) Then

                    'capture current instrument
                    VolumeChangeAmount_old(Chan) = CurrentVoice(Chan).VolumeChangeAmount
                    CurrentVoice(Chan) = GetCurrentVoice(Chan)

                    'compare with insturment list and add if its not there, get instrument number
                    VoiceID_old(Chan) = VoiceID(Chan)
                    VoiceID(Chan) = FindVoice(CurrentVoice(Chan).Voice)

                    'if instrument number has changed, send program change command
                    If (VoiceID_old(Chan) <> VoiceID(Chan)) Then
                        Send_Midi(&HC0 + Chan, VoiceID(Chan), -1)
                    End If

                    'if volume change amount has changed then send volume command
                    If (VolumeChangeAmount_old(Chan) <> CurrentVoice(Chan).VolumeChangeAmount) Then

                        Vol = -(CurrentVoice(Chan).VolumeChangeAmount * 0.75)
                        Vol = (10 ^ (Vol / 40)) * 127
                        Vol = Vol * Gain

                        If (Vol > MaxVol) Then MaxVol = Vol

                        If Vol > 127 Then Vol = 127
                        If Vol < 0 Then Vol = 0

                        Send_Midi(&HB0 + Chan, 7, Vol)
                    End If

                    RegisterChanged = False
                    'End If

                    NoteOn(Chan) = True
                Else
                    NoteOn(Chan) = False
                End If

                If (NoteOn_Old(Chan) <> NoteOn(Chan)) Then
                    If (NoteOn(Chan)) Then
                        If (Note(Chan) >= 0) Then
                            Send_Midi(&H90 + Chan, Note(Chan), 127)
                        Else
                            ListBox2.Items.Add("Key on occured before note was set!")
                        End If
                    Else
                        If (Note(Chan) >= 0) Then Send_Midi(&H80 + Chan, Note(Chan), 0)
                    End If
                End If

            Case &H28 To &H2F
                'Key code, 3 bits octave and 4 bits note
                Chan = ym_reg And &H7
                Note_Old(Chan) = Note(Chan)
                Note(Chan) = KeyCodeToMIDINote(ym_val)

                If (NoteOn(Chan) And (Note(Chan) <> Note_Old(Chan))) Then
                    If (Note_Old(Chan) >= 0) Then Send_Midi(&H80 + Chan, Note_Old(Chan), 0)
                    Send_Midi(&H90 + Chan, Note(Chan), 127)
                End If

            Case &H30 To &H37
                'Key fraction
                Chan = ym_reg And &H7

                KF(Chan) = ym_val >> 2

                If (KF(Chan) <> KF_old(Chan)) Then
                    'ListBox4.Items.Add("Key fraction chan= " + Chan.ToString + " val= " + KF(Chan).ToString)
                    KF_old(Chan) = KF(Chan)

                    'Pitch bend range should be 2 semitones

                    KF_PB = KF(Chan) * 64
                    KF_PB = KF_PB + 8192

                    Send_Midi(&HE0 + Chan, KF_PB And &H7F, KF_PB >> 7)
                End If

            Case &H19
                'Phase or amplitude modulation depth (AMD / PMD)

                If ((ym_val And &H80) = 0) Then
                    'AMD
                    AMD = ym_val And 127
                Else
                    'PMD
                    PMD = ym_val And 127
                End If

                RegisterChanged = True

            Case &H18, &H1B, &H20 To &HFF
                RegisterChanged = True

        End Select

    End Sub

    Private Sub Parse()

        Select Case (d(0))
            Case &H30 To &H3F, &H4F, &H50
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H40 To &H4E, &H51 To &H53, &H55 To &H5F, &HA0 To &HBF
                in_file.Read(d, 0, 2) : filepos = filepos + 2
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &HC0 To &HDF, &H64
                in_file.Read(d, 0, 3) : filepos = filepos + 3
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &HE0 To &HEF
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H54
                in_file.Read(d, 0, 2) : filepos = filepos + 2
                'YM2151, write value d(1) to register d(0)
                ym_reg = d(0)
                ym_val = d(1)
                in_file.Read(d, 0, 1) : filepos = filepos + 1

                SendYM()

            Case &H61
                in_file.Read(d, 0, 2) : filepos = filepos + 2
                'wait number of samples
                delay = delay + BytesToInt16(d)
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H62
                'wait 735 samples (1/60 seconds)
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                delay = delay + 735
            Case &H63
                'wait 882 samples (1/50 seconds)
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                delay = delay + 882
            Case &H66
                'end of sound data
                'ListBox1.Items.Add("end of sound data at " + filepos.ToString)
                filepos = filelength
                'file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H67
                'ListBox1.Items.Add("data block at " + filepos.ToString)
                'data block...
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                filepos = filepos + BytesToInt32(d)
                If (filepos < 0) Then
                    filepos = filelength
                    'ListBox1.Items.Add("Abort at " + filepos.ToString)
                End If

                in_file.Seek(filepos, SeekOrigin.Begin)
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H68
                'PCM RAM write...
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 3) : filepos = filepos + 3
                in_file.Read(d, 0, 3) : filepos = filepos + 3
                in_file.Read(d, 0, 3) : filepos = filepos + 3

                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H70 To &H8F
                'wait number of samples (use lower nibble of command)
                delay = delay + (d(0) And 15)
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H90, &H91, &H95
                'DAC stream control...
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H92
                'DAC stream control...
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H93
                'DAC stream control...
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 4) : filepos = filepos + 4
                in_file.Read(d, 0, 1) : filepos = filepos + 1
            Case &H94
                'DAC stream control...
                in_file.Read(d, 0, 1) : filepos = filepos + 1
                in_file.Read(d, 0, 1) : filepos = filepos + 1
        End Select
    End Sub

    Private Sub ParseLoop()

        Dim a As Integer

        'Do While ((filepos < filelength) And (abort = False))
        Do While (filepos < filelength)
            a = 0
            Do While ((filepos < filelength) And (a < 5))
                Parse()
                a = a + 1
            Loop
            'Application.DoEvents()
        Loop

        in_file.Close()

    End Sub

    Private Function Checksum(data() As Byte) As Byte

        Dim check As Integer
        Dim check_frlp As Integer

        check = 0
        For check_frlp = 0 To data.Length - 1
            check = check + data(check_frlp)
        Next
        check = ((Not check) + 1) And 127

        Return check

    End Function

    Private Function Voice_to_FB01(Voice As Voice_Struct) As Byte()

        Dim fb01_voice(63) As Byte
        Dim frlp As Integer
        Dim TL As Integer
        Dim op2 As Integer
        Dim car As Integer

        fb01_voice = {83, 105, 110, 101, 87, 97, 118, 0, 205, 128, 0, 120, 0, 0, 64, 0,
              127, 0, 0, 1, 31, 128, 0, 15, 127, 0, 0, 1, 31, 128, 0, 15,
              127, 0, 0, 1, 31, 128, 0, 15, 0, 0, 0, 1, 31, 128, 0, 15,
              0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}

        If (Voice.Name <> "") Then
            For frlp = 0 To 6
                If (frlp < Voice.Name.Length) Then
                    fb01_voice(frlp) = Asc(Mid(Voice.Name, frlp + 1, 1))
                Else
                    fb01_voice(frlp) = Asc(" ")
                End If
            Next

            fb01_voice(7) = 0     'Users code
            fb01_voice(8) = Voice.LFRQ And 255
            fb01_voice(9) = Voice.AMD And 127
            fb01_voice(10) = Voice.PMD And 127
            fb01_voice(11) = Voice.SLOT And 120
            fb01_voice(12) = ((Voice.FL And 7) << 3) + (Voice.CON And 7)
            fb01_voice(13) = (Voice.AMS And 3) + ((Voice.PMS And 7) << 4)
            fb01_voice(14) = (Voice.WF And 3) << 5
            fb01_voice(15) = 0    'Transpose

            For frlp = 0 To 3
                If (Carrier((Voice.CON And 7), frlp)) Then
                    car = 1
                Else
                    car = 0
                End If

                TL = Voice.Op(frlp).TL
                If (car = 0) Then TL = TL - 8
                If (TL < 0) Then
                    ListBox2.Items.Add("TL was less than 0")
                    TL = 0
                End If

                Select Case (frlp)
                    Case 0 : op2 = 0
                    Case 1 : op2 = 2
                    Case 2 : op2 = 1
                    Case 3 : op2 = 3
                End Select

                fb01_voice(op2 * 8 + 16) = TL And 127
                fb01_voice(op2 * 8 + 17) = 0      'KStype, Velocity sensitivity
                fb01_voice(op2 * 8 + 18) = 0      'Level Scaling, TL adjust
                fb01_voice(op2 * 8 + 19) = (Voice.Op(frlp).MUL And 15) + ((Voice.Op(frlp).DT1 And 7) << 4)
                fb01_voice(op2 * 8 + 20) = (Voice.Op(frlp).AR And 31) + ((Voice.Op(frlp).KS And 3) << 6)
                'fb01_voice(op2 * 8 + 21) = (Voice.Op(frlp).AME And 128) + (Voice.Op(frlp).D1R And 31)
                fb01_voice(op2 * 8 + 21) = (car << 7) + (Voice.Op(frlp).D1R And 31)
                fb01_voice(op2 * 8 + 22) = (Voice.Op(frlp).D2R And 31) + ((Voice.Op(frlp).DT2 And 3) << 6)
                fb01_voice(op2 * 8 + 23) = (Voice.Op(frlp).RR And 15) + ((Voice.Op(frlp).D1L And 15) << 4)
            Next

            For frlp = 48 To 57
                fb01_voice(frlp) = 0       'Reserved
            Next

            fb01_voice(58) = 0      'Poly / mono, Portamento speed
            fb01_voice(59) = 2      'Input controller (PMD), Pitch bender range
            fb01_voice(60) = 0      'Reserved
            fb01_voice(61) = 0      'Reserved
            fb01_voice(62) = 0      'Reserved
            fb01_voice(63) = 0      'Reserved
        End If

        Return fb01_voice

    End Function

    Private Sub WriteInsts()

        Dim syx_buff() As Byte
        Dim length As Integer
        Dim fb01_voice() As Byte
        Dim op2 As Integer
        Dim st As String

        out_file_syx.WriteByte(&HF0)
        out_file_syx.WriteByte(&H43)
        out_file_syx.WriteByte(&H75)
        out_file_syx.WriteByte(0)       'System number
        out_file_syx.WriteByte(0)       'Message number
        out_file_syx.WriteByte(0)       'Operation number
        out_file_syx.WriteByte(0)       'Bank number

        ReDim syx_buff(63)
        Array.Clear(syx_buff, 0, syx_buff.Length)
        syx_buff(0) = Asc("O") And &HF
        syx_buff(1) = (Asc("O") And &HF0) >> 4
        syx_buff(2) = Asc("P") And &HF
        syx_buff(3) = (Asc("P") And &HF0) >> 4
        syx_buff(4) = Asc("M") And &HF
        syx_buff(5) = (Asc("M") And &HF0) >> 4
        syx_buff(6) = Asc(" ") And &HF
        syx_buff(7) = (Asc(" ") And &HF0) >> 4
        syx_buff(8) = Asc("B") And &HF
        syx_buff(9) = (Asc("B") And &HF0) >> 4
        syx_buff(10) = Asc("a") And &HF
        syx_buff(11) = (Asc("a") And &HF0) >> 4
        syx_buff(12) = Asc("n") And &HF
        syx_buff(13) = (Asc("n") And &HF0) >> 4
        syx_buff(14) = Asc("k") And &HF
        syx_buff(15) = (Asc("k") And &HF0) >> 4

        length = syx_buff.Length
        out_file_syx.WriteByte((length And &HFF00) >> 8)   'Size (High byte)
        out_file_syx.WriteByte(length And &HFF)            'Size (Low byte)
        out_file_syx.Write(syx_buff, 0, syx_buff.Length)
        out_file_syx.WriteByte(Checksum(syx_buff))

        out_file_opm.WriteLine("//Created by VGM_to_MID by W.J.Holt")
        out_file_opm.WriteLine()

        ReDim syx_buff(127)

        For frlp = 0 To 47

            If (frlp < VoicesCount) Then
                Voices(frlp).Name = "Inst " + frlp.ToString
                fb01_voice = Voice_to_FB01(Voices(frlp))
                out_file_opm.WriteLine("@:" + frlp.ToString + " " + "Inst_" + frlp.ToString)
                out_file_opm.WriteLine("//  LFRQ AMD PMD WF NFRQ")
                out_file_opm.WriteLine("LFO: " + Voices(frlp).LFRQ.ToString + "  " +
                                       Voices(frlp).AMD.ToString + "  " +
                                       Voices(frlp).PMD.ToString + "  " +
                                       Voices(frlp).WF.ToString + "  " +
                                       Voices(frlp).NFRQ.ToString)
                out_file_opm.WriteLine("// PAN FL CON AMS PMS SLOT NE")
                out_file_opm.WriteLine("CH: " + "64" + "  " +
                                       Voices(frlp).FL.ToString + "  " +
                                       Voices(frlp).CON.ToString + "  " +
                                       Voices(frlp).AMS.ToString + "  " +
                                       Voices(frlp).PMS.ToString + "  " +
                                       Voices(frlp).SLOT.ToString + "  " +
                                       Voices(frlp).NE.ToString)
                out_file_opm.WriteLine("//  AR D1R D2R RR D1L  TL KS MUL DT1 DT2 AMS-EN")

                For frlp2 = 0 To 3
                    st = ""
                    Select Case (frlp2)
                        Case 0
                            op2 = 0
                            st = "M1: "
                        Case 1
                            op2 = 2
                            st = "C1: "
                        Case 2
                            op2 = 1
                            st = "M2: "
                        Case 3
                            op2 = 3
                            st = "C2: "
                    End Select

                    out_file_opm.WriteLine(st + Voices(frlp).Op(op2).AR.ToString + "  " +
                                       Voices(frlp).Op(op2).D1R.ToString + "  " +
                                       Voices(frlp).Op(op2).D2R.ToString + "  " +
                                       Voices(frlp).Op(op2).RR.ToString + "  " +
                                       Voices(frlp).Op(op2).D1L.ToString + "  " +
                                       Voices(frlp).Op(op2).TL.ToString + "  " +
                                       Voices(frlp).Op(op2).KS.ToString + "  " +
                                       Voices(frlp).Op(op2).MUL.ToString + "  " +
                                       Voices(frlp).Op(op2).DT1.ToString + "  " +
                                       Voices(frlp).Op(op2).DT2.ToString + "  " +
                                       Voices(frlp).Op(op2).AME.ToString)

                Next frlp2

                out_file_opm.WriteLine()

            Else
                fb01_voice = Voice_to_FB01(Voices(VoicesCount - 1))
            End If

            For frlp2 = 0 To 63
                syx_buff(frlp2 * 2) = fb01_voice(frlp2) And &HF
                syx_buff((frlp2 * 2) + 1) = (fb01_voice(frlp2) And &HF0) >> 4
            Next

            length = syx_buff.Length * 2
            out_file_syx.WriteByte((length And &HFF00) >> 8)   'Size (High byte)
            out_file_syx.WriteByte(length And &HFF)            'Size (Low byte)
            out_file_syx.Write(syx_buff, 0, syx_buff.Length)
            out_file_syx.WriteByte(Checksum(syx_buff))

        Next

        out_file_syx.WriteByte(&HF7)

    End Sub

    Private Sub WriteMIDIHeader()

        Dim buff() As Byte
        ReDim buff(13)

        out_file_midi.Seek(0, SeekOrigin.Begin)

        buff(0) = Asc("M")
        buff(1) = Asc("T")
        buff(2) = Asc("h")
        buff(3) = Asc("d")
        buff(4) = 0
        buff(5) = 0
        buff(6) = 0
        buff(7) = 6                 'MThd chunk length is always 0006
        buff(8) = 0
        buff(9) = 1                 'Format 1
        buff(10) = 0
        buff(11) = 1                '1 Track
        buff(12) = (TQN >> 8) And &HFF
        buff(13) = TQN And &HFF     'ticks per quater note

        out_file_midi.Write(buff, 0, buff.Length)

        ReDim buff(7)

        buff(0) = Asc("M")
        buff(1) = Asc("T")
        buff(2) = Asc("r")
        buff(3) = Asc("k")
        buff(4) = (MIDIByteCount >> 24) And &HFF
        buff(5) = (MIDIByteCount >> 16) And &HFF
        buff(6) = (MIDIByteCount >> 8) And &HFF
        buff(7) = MIDIByteCount And &HFF

        out_file_midi.Write(buff, 0, buff.Length)

    End Sub

    Private Function Carrier(alg As Integer, op As Integer) As Boolean

        Dim c As Boolean

        c = False

        Select Case (op)
            Case 0  'M1
                If (alg = 7) Then
                    c = True
                End If
            Case 2  'C1
                If (alg >= 4 And alg <= 7) Then
                    c = True
                End If
            Case 1  'M2
                If (alg >= 5 And alg <= 7) Then
                    c = True
                End If
            Case 3  'C2
                c = True
        End Select

        Return c

    End Function

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click

        Dim b(1) As Byte
        Dim filename As String
        Dim pathname As String
        Dim frlp As Integer
        Dim temp As Double
        Dim BPM_Period As Integer

        ListBox1.Items.Clear()
        ListBox2.Items.Clear()

        'we need to check if file is already open

        If (in_file IsNot Nothing) Then in_file.Close()
        in_file = New FileStream(TextBox1.Text, FileMode.Open)

        in_file.Read(d, 0, 4)
        If (BytesToText(d, 4) <> "Vgm ") Then in_file.Close() : Exit Sub

        in_file.Read(d, 0, 4)
        filelength = BytesToInt32(d) + 4
        If (filelength > in_file.Length) Then in_file.Close() : Exit Sub
        ListBox1.Items.Add("File length is: " + filelength.ToString + " bytes")

        in_file.Seek(&H30, SeekOrigin.Begin)
        in_file.Read(d, 0, 4)
        temp = BytesToInt32(d)
        If (temp <> 0) Then
            ListBox1.Items.Add("YM2151 Frequency is: " + temp.ToString + " MHz")
        Else
            in_file.Close()
            Exit Sub
        End If

        in_file.Read(d, 0, 4)
        temp = BytesToInt32(d)
        If (temp = 0) Then temp = 12
        filepos = temp + &H34
        in_file.Seek(filepos, SeekOrigin.Begin)
        ListBox1.Items.Add("Data starts at: " + filepos.ToString)

        delay = 0

        in_file.Read(d, 0, 1) : filepos = filepos + 1

        pathname = Path.GetDirectoryName(TextBox1.Text)
        filename = Path.GetFileNameWithoutExtension(TextBox1.Text)

        out_file_midi = New FileStream(pathname + "\" + filename + ".mid", FileMode.Create)

        MIDIByteCount = 0
        VoicesCount = 0
        RegisterChanged = False
        ReDim Voices(0)
        For frlp = 0 To 7
            Note_Old(frlp) = -1
            NoteOn_Old(frlp) = False
            KF_old(frlp) = -1
            VoiceID_old(frlp) = -1
            VolumeChangeAmount_old(frlp) = -1

            Note(frlp) = -2
            NoteOn(frlp) = False
            KF(frlp) = -2
            VoiceID(frlp) = -2
            CurrentVoice(frlp).VolumeChangeAmount = -2
        Next
        Array.Clear(Registers, 0, Registers.Length)
        TL_Tol = Val(TextBox2.Text)
        MaxVol = 0
        Gain = Val(TextBox3.Text)

        BPM = Val(TextBox4.Text)
        TQN = Val(TextBox5.Text)
        ListBox2.Items.Add("Ticks per quarter note = " + TQN.ToString)

        WriteMIDIHeader()

        BPM_Period = 60000000
        BPM_Period = BPM_Period / BPM

        Send_Midi(&HFF, &H51, 3)    'Set BPM
        out_file_midi.WriteByte((BPM_Period And &HFF0000) >> 16) : MIDIByteCount = MIDIByteCount + 1
        out_file_midi.WriteByte((BPM_Period And &HFF00) >> 8) : MIDIByteCount = MIDIByteCount + 1
        out_file_midi.WriteByte(BPM_Period And &HFF) : MIDIByteCount = MIDIByteCount + 1

        For frlp = 0 To 7
            Send_Midi(&HE0 + frlp, 8192 And &H7F, 8192 >> 7)
        Next

        ParseLoop()

        Send_Midi(&HFF, &H2F, 0)    'End of track

        WriteMIDIHeader()   'Do it again to update number of bytes written to the track

        out_file_midi.Close()

        out_file_syx = New FileStream(pathname + "\" + filename + ".syx", FileMode.Create)
        out_file_opm = My.Computer.FileSystem.OpenTextFileWriter(pathname + "\" + filename + ".opm", False, utf8WithoutBom)

        WriteInsts()

        out_file_syx.Close()
        out_file_opm.Close()

        ListBox2.Items.Add("Number of voices found: " + VoicesCount.ToString)
        temp = Int(MaxVol * 1000) / 1000
        ListBox2.Items.Add("Maximum volume was: " + temp.ToString + " out of 127")
        temp = Int(((127 / MaxVol) * Gain) * 1000) / 1000
        ListBox2.Items.Add("Set gain to: " + temp.ToString + " to get best result")
        ListBox2.Items.Add("Conversion complete")

    End Sub

    Private Function KeyCodeToMIDINote_Old(data As Integer) As Integer

        Dim FNum As Integer
        Dim Block As Integer
        Dim NoteVal As Integer

        FNum = data And &HF
        Block = (data And &H70) >> 4

        If (CheckBox1.Checked) Then Block = Block - 1
        'If (Block < 0) Then Block = 0

        If Not ((FNum And &H3) = &H3) Then

            NoteVal = (FNum And &HC) / &H4
            NoteVal = NoteVal * 3 + (FNum And &H3)

            If (NoteVal < 11) Then
                NoteVal = 61 + NoteVal
            Else
                NoteVal = 60
            End If

        Else
            NoteVal = &HFF
            ListBox2.Items.Add("Note value was 255")
        End If

        If NoteVal = &HFF Then
            Return (&HFF)
        Else
            Return (NoteVal + (Block - &H4) * 12)
        End If

    End Function

    Private Function KeyCodeToMIDINote(data As Integer) As Integer

        Dim FNum As Integer
        Dim Octave As Integer
        Dim NoteVal As Integer

        FNum = data And &HF
        Octave = (data And &H70) >> 4

        If (CheckBox1.Checked) Then Octave = Octave - 1
        'If (Block < 0) Then Block = 0

        NoteVal = 0

        Select Case (FNum)
            Case 0
                'C#
                NoteVal = 61
            Case 1
                'D
                NoteVal = 62
            Case 2
                'D#
                NoteVal = 63
            Case 3
                'Undefined
            Case 4
                'E
                NoteVal = 64
            Case 5
                'F
                NoteVal = 65
            Case 6
                'F#
                NoteVal = 66
            Case 7
                'Undefined
            Case 8
                'G
                NoteVal = 67
            Case 9
                'G#
                NoteVal = 68
            Case 10
                'A
                NoteVal = 69
            Case 11
                'Undefined
            Case 12
                'A#
                NoteVal = 70
            Case 13
                'B
                NoteVal = 71
            Case 14
                'C
                NoteVal = 72
            Case 15
                'Undefined

        End Select

        If (NoteVal <> 0) Then
            NoteVal = NoteVal + ((Octave - 4) * 12)
        Else
            ListBox2.Items.Add("Note value was invalid")
        End If

        If (NoteVal < 0) Then
            ListBox2.Items.Add("Note value was less than 0")
            NoteVal = 0
        End If

        Return (NoteVal)

    End Function

    Private Sub TextBox1_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles TextBox1.DragDrop
        Dim s() As String = e.Data.GetData("FileDrop", False)

        TextBox1.Text = s(0)
    End Sub

    Private Sub TextBox1_DragEnter(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles TextBox1.DragEnter
        e.Effect = DragDropEffects.All
    End Sub

    Private Function BytesToText(b() As Byte, l As Integer) As String

        Dim i As Integer
        Dim st As String

        st = ""
        For i = 0 To l - 1
            st = st + Chr(b(i))
        Next

        BytesToText = st

    End Function

    Private Function BytesToInt32(b() As Byte) As Integer

        Dim v As Integer

        v = b(3)
        v = (v << 8) Or b(2)
        v = (v << 8) Or b(1)
        v = (v << 8) Or b(0)

        BytesToInt32 = v

    End Function

    Private Function BytesToInt24(b() As Byte) As Integer

        Dim v As Integer

        v = b(2)
        v = (v << 8) Or b(1)
        v = (v << 8) Or b(0)

        BytesToInt24 = v

    End Function

    Private Function BytesToInt16(b() As Byte) As Integer

        Dim v As Integer

        v = b(1)
        v = (v << 8) Or b(0)

        BytesToInt16 = v

    End Function

End Class
